#include <windows.h>
#include <stdio.h>

// prototype for the printError function defined below
void printError(char* functionName);


/***********************************************************
   This function opens the floppy disk drive (i.e., drive A)
   for sector by sector access.

   This function should use the Win32 function CreateFile to
   open the floppy disk and get a handle to it. The CreateFile
   function actually opens the floppy disk as one long file that
   can be accessed byte by byte. This lets you access every sector
   of the floppy, even the normally "hidden" system sectors.

   Read the Win32 documentation for the CreateFile function. In
   particular, look for the section called "Physical Disks" (or
   "Disk Devices", depending on the version of the documentation
   that you look in) near the end of the CreateFile help page.
   That is where there is specific information about opening a
   floppy disk drive.
   .
   If you run this program as the Windows administrator, you
   can also open other drives (but do not even think about
   writing to any drive but the A drive).

   Be sure to error check all of your Win32 function calls.

   This function returns a handle to the "disk".
*/
HANDLE physicalDisk(char driveLetter)
{

   /* your code here */

}//physicalDisk


/*************************************************************
   This function reads a sector from the disk device pointed
   to by the handle. This function reads 512 bytes from the
   stream that represents the disk device and stores those
   bytes into the buffer. Before reading the 512 bytes from the
   stream, this function should use the Win32 SetFilePointer
   function to position the file pointer for the stream at the
   first byte of the sector to be read. Notice that SetFilePointer
   should only be used to set the file pointer at sector boundaries,
   i.e., every 512 bytes from beginning of the stream.

   Read the Win32 documentation about the SetFilePointer function.
   In particular, pay attention to this function's fourth parameter,
   called dwMoveMethod.

   Be sure to error check all of your Win32 function calls.
*/
void sectorRead(HANDLE theDisk, unsigned int logicalSectorNumber, unsigned char *buffer)
{

   /* your code here */

}//sectorRead


/***************************************************************
   This function prints out a hex and ASCII listing of the
   contents of one sector from the floppy. This function should
   call readSector() to actually read the sector. Here is an
   example of what the first few lines of a sector dump should
   look like (the whole sector dump would be 32 lines long). The
   dots on the right hand side represent non printing characters.

Dump of logical sector number 0:
   EB 3C 90 4D 53 44 4F 53 35 2E 30 00 02 01 01 00    .<.MSDOS5.0.....
   02 E0 00 40 0B F0 09 00 12 00 02 00 00 00 00 00    ...@............
   00 00 00 00 00 00 29 49 10 6E 74 4E 4F 20 4E 41    ......)I.ntNO NA
   4D 45 20 20 20 20 46 41 54 31 32 20 20 20 33 C9    ME    FAT12   3.
*/
void sectorDump(HANDLE theDisk, int logicalSectorNumber)
{

   /* your code here */

}//sectorDump


/****************************************************************
   The following function can be used to print out "meaningful"
   error messages. If you call a Win32 function and it returns
   with an error condition, then call this function right away and
   pass it a string containing the name of the Win32 function that
   failed. This function will print out a reasonable text message
   explaining the error and then terminate the program.
*/
void printError(char* functionName)
{   LPVOID lpMsgBuf;
    int error_no;
    error_no = GetLastError();
    FormatMessage(
         FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
         NULL,
         error_no,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
         (LPTSTR) &lpMsgBuf,
         0,
         NULL
    );
    // Display the string.
    fprintf(stderr, "\n%s failed on error %d: ", functionName, error_no);
    fprintf(stderr, lpMsgBuf);
    // Free the buffer.
    LocalFree( lpMsgBuf );
    ExitProcess(1);  // terminate the program
}//printError