/*
    NOTE: For this to compile, you need your header file floppy.h
          from homework assignment 7.
*/
#include <windows.h>
#include <stdio.h>
#include "floppy.h"
#include "floppyFAT.h"

int main(int argc, char *argv[])
{
   int i = 0;
   HANDLE floppy;
   unsigned char buffer[9*512]; // Buffer to hold all 9 FAT sectors.
   int unpackedFAT[3072];       // Array to hold the unpacked FAT entries.
   int objectCount;             // Number of objects stored on the floppy.

   // Open the floppy disk.
   floppy = physicalDisk('A');

   // Read the FAT sectors into the buffer.
   fatRead(floppy, buffer);

   // Unpack the FAT into the array.
   unpackFAT(buffer, unpackedFAT);

   // Use the unpacked FAT to count the number of objects on the floppy.
   objectCount = countObjects(unpackedFAT);
   printf("There are %d objects stored on the floppy disk.\n", objectCount);

   // Print out part of the FAT to see what it looks like.
   for (i = 0; i < 25; i++)
   {
      printf("FAT[%d] = %d\n", i, unpackedFAT[i]);
   }

   // Close the floppy.
   CloseHandle(floppy);

   return 0;
}//main
